package io.ient.test;

import io.ient.test.context.FrameworkTestBase;
import io.ient.test.facets.Login;
import io.ient.test.framework.selenium.WaitTime;
import io.ient.test.framework.utils.DateUtils;
import io.ient.test.framework.utils.RandomDataUtils;
import io.ient.test.framework.utils.annotations.TestCaseID;
import io.ient.test.pages.HomePage;
import io.ient.test.pages.enterprise.*;
import org.testng.annotations.Test;
import org.testng.asserts.SoftAssert;

public class SupplierInvoicesTest extends FrameworkTestBase {

    @TestCaseID(ids = {"PRE-CONDITION"})
    @Test
    public void verifyPurchaseOrderCreation() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        SupplierInvoicesPage supplierInvoicesPage = new SupplierInvoicesPage(driver);
        homePage.clickOnPurchaseOrderApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String purchaseNumber = RandomDataUtils.randomNumeric(4);
        String sapReferenceNumber = RandomDataUtils.randomNumeric(4);
        String startDateInPurchaseOrder = DateUtils.getFormattedDateAndTimeWithTimeZone(1, 0,"d","IST");
        String endDateInPurchaseOrder = DateUtils.getFormattedDateAndTimeWithTimeZone(15, 0,"d","IST");
        String currencyPreference = "1";
        String submitToSupplierStatus = "Submit To Supplier";
        String shortDescription = "Desc_" + RandomDataUtils.getRandomAlphanumeric(5);
        String supplierId = "1";
        String supplierAdmin = testContext.app.getSupplierAdminUser();
        String supplierAdminUsername = supplierAdmin;
        String month = "12";
        String year = "2022";
        String acceptedStatus = "Accepted";
        supplierInvoicesPage.createPurchaseOrder(purchaseNumber, sapReferenceNumber, startDateInPurchaseOrder, endDateInPurchaseOrder, currencyPreference, submitToSupplierStatus, shortDescription, supplierId, supplierAdminUsername, month, year);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(purchaseNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean purchaseOrderDisplayStatus_BA = bulletinSubscriptionsPage.isRecordDisplayed(purchaseNumber);
        softAssert.assertTrue(purchaseOrderDisplayStatus_BA, "Failed to create purchase order");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnPurchaseOrderApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(purchaseNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        supplierInvoicesPage.editCase(shortDescription, acceptedStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(purchaseNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean purchaseOrderDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayed(purchaseNumber);
        softAssert.assertTrue(purchaseOrderDisplayStatus, "Failed to edit and accept purchase order");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-2743" , "IENT-2746"})
    @Test
    public void verifySupplierInvoiceReject() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        SupplierInvoicesPage supplierInvoicesPage = new SupplierInvoicesPage(driver);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String startDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(5, 0,"d","IST");
        String endDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(8, 0,"d","IST");
        String rejectReason = "Test_" + RandomDataUtils.getRandomAlphanumeric(5);
        String purchaseOrderNumber = "1";
        String invoiceNumber = RandomDataUtils.randomNumeric(7);
        String invoiceGrossAmount = RandomDataUtils.randomNumeric(4);
        String approverName = testContext.app.getBuyerUser();
        supplierInvoicesPage.createSupplierInvoice(startDateInSupplierInvoice, endDateInSupplierInvoice, purchaseOrderNumber, invoiceNumber, invoiceGrossAmount, approverName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(displayStatus, "Failed to create supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String rejectedStatus = "Rejected";
        supplierInvoicesPage.editStatus(rejectedStatus, rejectReason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceDisplayStatus, "Failed to display supplier invoice");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-2744" , "IENT-2745" , "IENT-2747", "IENT-2840"})
    @Test
    public void verifySupplierInvoiceReworkOpenApproved() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        SupplierInvoicesPage supplierInvoicesPage = new SupplierInvoicesPage(driver);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String startDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(5, 0,"d","IST");
        String endDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(8, 0,"d","IST");
        String reason = "Test_" + RandomDataUtils.getRandomAlphanumeric(5);
        String purchaseOrderNumber = "1";
        String invoiceNumber = RandomDataUtils.randomNumeric(7);
        String invoiceGrossAmount = RandomDataUtils.randomNumeric(4);
        String approverName = testContext.app.getBuyerUser();
        supplierInvoicesPage.createSupplierInvoice(startDateInSupplierInvoice, endDateInSupplierInvoice, purchaseOrderNumber, invoiceNumber, invoiceGrossAmount, approverName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayCreationStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(displayCreationStatus, "Failed to create supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String reworkStatus = "Rework";
        String openStatus = "Open ";
        String approvedStatus = "Approved";
        supplierInvoicesPage.editStatus(reworkStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceReworkStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceReworkStatus, "Failed to rework supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        supplierInvoicesPage.editStatus(openStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceOpenStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceOpenStatus, "Failed to open supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        supplierInvoicesPage.editStatus(approvedStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceApprovedStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceApprovedStatus, "Failed to approved supplier invoice");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-2748-1"})
    @Test
    public void verifySupplierInvoiceFeedbackApprovedSettled() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        SupplierInvoicesPage supplierInvoicesPage = new SupplierInvoicesPage(driver);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String startDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(5, 0, "d", "IST");
        String endDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(8, 0, "d", "IST");
        String reason = "Test_" + RandomDataUtils.getRandomAlphanumeric(5);
        String purchaseOrderNumber = "1";
        String invoiceNumber = RandomDataUtils.randomNumeric(7);
        String invoiceGrossAmount = RandomDataUtils.randomNumeric(4);
        String approverName = testContext.app.getBuyerUser();
        supplierInvoicesPage.createSupplierInvoice(startDateInSupplierInvoice, endDateInSupplierInvoice, purchaseOrderNumber, invoiceNumber, invoiceGrossAmount, approverName);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayCreationStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(displayCreationStatus, "Failed to create supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String approvedStatus = "Approved";
        String rejectedStatus = "Rejected";
        String feedbackStatus = "Feedback";
        String settledStatus = "Settled";
        supplierInvoicesPage.editStatus(approvedStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceApprovedStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceApprovedStatus, "Failed to approved supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        supplierInvoicesPage.editStatus(feedbackStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceFeedbackStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceFeedbackStatus, "Failed to feedback supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        supplierInvoicesPage.editStatus(approvedStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceApprovedStatus_BU = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceApprovedStatus_BU, "Failed to approved supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        supplierInvoicesPage.editStatus(settledStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceSettledStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceSettledStatus, "Failed to settled supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
    }

    @TestCaseID(ids = {"IENT-2748-2"})
    @Test
    public void verifySupplierInvoiceApprovedRejected() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        SupplierInvoicesPage supplierInvoicesPage = new SupplierInvoicesPage(driver);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String startDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(5, 0, "d", "IST");
        String endDateInSupplierInvoice = DateUtils.getFormattedDateAndTimeWithTimeZone(8, 0, "d", "IST");
        String reason = "Test_" + RandomDataUtils.getRandomAlphanumeric(5);
        String purchaseOrderNumber = "1";
        String invoiceNumber = RandomDataUtils.randomNumeric(7);
        String invoiceGrossAmount = RandomDataUtils.randomNumeric(4);
        String approverName = testContext.app.getBuyerUser();
        supplierInvoicesPage.createSupplierInvoice(startDateInSupplierInvoice, endDateInSupplierInvoice, purchaseOrderNumber, invoiceNumber, invoiceGrossAmount, approverName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayCreationStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(displayCreationStatus, "Failed to create supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String approvedStatus = "Approved";
        String rejectedStatus = "Rejected";
        supplierInvoicesPage.editStatus(approvedStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceApprovedStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceApprovedStatus, "Failed to approved supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnSupplierInvoicesApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        supplierInvoicesPage.editStatus(rejectedStatus, reason);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(invoiceNumber);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean supplierInvoiceRejectedStatus = bulletinSubscriptionsPage.isRecordDisplayed(invoiceNumber);
        softAssert.assertTrue(supplierInvoiceRejectedStatus, "Failed to rejected supplier invoice");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
    }

}